my $g_file;

sub file_new {
  # Check that the current picture is empty
  # Erase the current picture
  foreach(keys %Stack::stack) { delete $Stack::stack{$_}; }
  $w_canvas->delete("item");  
}
sub file_load { 
  my $f = $w_top->FileSelect(-filter => "*.tex", -title => "Load");
  my $new_file = $f->Show;
  return unless defined $new_file;
  file_new();
  my %id;
  # Open the file
  if( open(F,"$new_file") ) {
    # Read it
    my $all  ;
    foreach (<F>){ if(s/^\%//){ $all .= $_; } }
    close(F);
    print STDERR "Evaluating: $all\n";
    eval $all;
    print STDERR "$@\n";
    # Change current file name
    $g_file = $new_file;
    $w_top->configure(-title => "Tableau: $g_file");
  } else { info("Cannot open $new_file: $!"); }
}
sub file_save {
  file_save_as() unless $g_file;
  if( open(F, ">$g_file") ){
    select(F);
    foreach(keys %Stack::stack){
      $Stack::stack{$_}->print;
    }
    latex();
    close(F);
  } else { info("cannot open $g_file for writing: $!"); }
}
sub file_save_as {
  my $f = $w_top->FileSelect(-filter => "*.tex", -title => "Save as");
  $g_file = $f->Show;
  if($g_file){
    file_save();
    $w_top->configure(-title => "Tableau: $g_file");
  }
}

sub file_quit {
  destroy $w_top;
}

sub help_about {
  info("Exemple trs simple de programme de Dessin, ralis en Perl, permettant de tracer le tableau de variations d'une fonction, comme on le fait au lyce et en DEUG. Le rsultat est un fichier LaTeX utilisant Xy-pic. Il convient de le voir plutt comme un exercice de programmation que comme un vritable programme conu pour tre utile.
(c) 1999 Vincent Zoonekynd <zoonek\@math.jussieu.fr>", " propos");
}

