sub info {
  my $text = shift;
  my $title = shift || "...";
  my $message = $w_top->Toplevel(-title => $title);
  $message->Label(-wraplength => '6i',
                  -justify    => 'left',
                  -text       => $text)->pack;
  $message->Canvas(-relief => 'raised', -borderwidth => 2, -height => 1)
          ->pack(-fill => 'x');
  my $b = $message->Frame;
  my $id = $w_top->after(50000, sub{ eval{ $message->destroy; }} );
  $b->pack(qw(-side bottom -fill x -pady 2m));
  $b->Button(-text    => 'OK',
             -command => sub { $message->afterCancel($id); $message->destroy; })
    ->pack(qw(-side right -expand 1));
  $b->bind('<Return>' => sub { $message->afterCancel($id); $message->destroy; })
;
}

sub stringify {
  my $string = shift;
  $string =~ s/\\/\\\\/g;
  $string =~ s/\"/\\\"/g;
  $string =~ s/\$/\\\$/g;
  $string =~ s/\%/\\\%/g;
  $string =~ s/\@/\\\@/g;
  $string =~ s/\&/\\\&/g;
  $string =~ s/\~/\\\~/g;
  $string =~ s/\#/\\\#/g;
  $string =~ s/\{/\\\{/g;
  $string =~ s/\}/\\\}/g;
  $string =~ s/\[/\\\]/g;
  return $string;
}
  