my $g_mode_line_x;
my $g_mode_line_y;

sub mode_line {
  set_mode_name("line");
  set_mouse_explainer("First point","","");
  remove_bindings;
  $w_canvas->delete('tmp');
  $w_canvas->Tk::bind('<1>' => \&mode_line_new);
}

sub mode_line_new {
  ($g_mode_line_x, $g_mode_line_y) = event_to_coords($w_canvas->XEvent);
  set_mouse_explainer("Second point","abort","");
  $w_canvas->Tk::bind('<1>' => \&mode_line_end);
  $w_canvas->Tk::bind('<Motion>' => \&mode_line_motion);
  $w_canvas->Tk::bind('<2>' => \&mode_line);
}  

sub mode_line_end {
  my($x,$y) = event_to_coords($w_canvas->XEvent);
  Line->new($g_mode_line_x, $g_mode_line_y, $x, $y);
  mode_line;
}

sub mode_line_motion {
  my($x,$y) = event_to_coords($w_canvas->XEvent);
  $w_canvas->delete('tmp');
  draw_line_tmp($g_mode_line_x, $g_mode_line_y, $x, $y);
}
