my $g_mode_text_anchor = 'center';

sub mode_text {
  set_mouse_explainer("text location","","");
  remove_bindings;
  $w_canvas->delete('tmp');
  $w_canvas->Tk::bind('<1>' => \&mode_text_new);
}
sub mode_text_new {
  my ($x, $y) = event_to_coords($w_canvas->XEvent);
  my $entry = $w_top->Entry(-relief => 'sunken', -width=>30);
  my $id = $w_canvas->createWindow($x * $g_grid_x, $y * $g_grid_y, -window => $entry);
  my $text;
  $entry->focus;
  $entry->bind('<Return>' => sub{$text=$entry->get;
				      destroy $entry;
                                      $w_canvas->delete($id);});
  $entry->waitWindow;
  Text->new($x,$y, $text, $g_mode_text_anchor);
}  

sub mode_text_center {
  set_mode_name("text (center)");
  $g_mode_text_anchor = 'center';
  mode_text();
}

sub mode_text_left {
  set_mode_name("text (left)");
  $g_mode_text_anchor = 'e';
  mode_text();
}

sub mode_text_right {
  set_mode_name("text (right)");
  $g_mode_text_anchor = 'w';
  mode_text();
}

