package main;

# Configuration par dfaut

# Squelette du fichier LaTeX utilis pour crer les images du texte 
# que l'on tape
my $g_latex_preamble = '
\documentclass{minimal}
\usepackage{amsmath,amsfonts}
\begin{document}
$$
';
my $g_latex_postamble = '$$\end{document}';

# Ce que l'on met au dbut ou  la fin du fichier cr
my $g_latex_final_preamble = '';
my $g_latex_final_postamble = '';

# Environement xy cr
my $g_xy_start = '\xy <0pt,0pt>;<1cm,0cm>:<0cm,-.5cm>::' ;
my $g_xy_end = '\endxy';

# Regarder s'il y a un fichier de configuration dans ~/.

my $home = getenv("HOME");
lstat("$home/.tableaurc");
if(-R _){
  open(F,"$home/.tableaurc") || warn "Cannot read ~/.tableaurc";
  my @tout = <F>;
  close(F);
    print STDERR "~/.tableaurc contains:\n";
    print STDERR "@tout\n";
  eval join(' ',@tout);
  if($@){
    print STDERR "Problem reading ~/.tableaurc\n";
    print STDERR "Errors: $@\n";
  }
}