sub mode_add_column {
  set_mode_name("add column");
  set_mouse_explainer("add column","remove column","");
  remove_bindings;
  $w_canvas->delete('tmp');
  $w_canvas->Tk::bind('<1>' => \&mode_add_column_here);
  $w_canvas->Tk::bind('<2>' => \&mode_remove_column_here);
}
sub mode_add_column_here {
  my($x,$y) = event_to_coords($w_canvas->XEvent);
  my $id;
  foreach $id (keys %Stack::stack) {
    my $obj = $Stack::stack{$id};
    if(defined($obj->{X})  and ($obj->{X}  >= $x)) { 
      $obj->{X}  ++; 
      $w_canvas->move("id:$id", $g_grid_x, 0); 
    }
    if(defined($obj->{X1}) and ($obj->{X1} >= $x)) { 
      $obj->{X1} ++; 
      $w_canvas->delete("id:$id"); $obj->draw;
    }
    if(defined($obj->{X2}) and ($obj->{X2} >= $x)) { 
      $obj->{X2} ++; 
      $w_canvas->delete("id:$id"); $obj->draw;
    }
  }
}  
sub mode_remove_column_here {
  my($x,$y) = event_to_coords($w_canvas->XEvent);
  my $id;
  foreach $id (keys %Stack::stack) {
    my $obj = $Stack::stack{$id};
    if(defined($obj->{X})  and $obj->{X}  > $x) { 
      $obj->{X}  --; 
      $w_canvas->move("id:$id", -$g_grid_x, 0); 
    }
    if(defined($obj->{X1}) and $obj->{X1} > $x) { 
      $obj->{X1} --; 
      $w_canvas->delete("id:$id"); $obj->draw;
    }
    if(defined($obj->{X2}) and $obj->{X2} > $x) { 
      $obj->{X2} --; 
      $w_canvas->delete("id:$id"); $obj->draw;
    }
  }
}  
