sub mode_add_line {
  set_mode_name("add line");
  set_mouse_explainer("add line","remove line","");
  remove_bindings;
  $w_canvas->delete('tmp');
  $w_canvas->Tk::bind('<1>' => \&mode_add_line_here);
  $w_canvas->Tk::bind('<2>' => \&mode_remove_line_here);
}
sub mode_add_line_here {
  my($x,$y) = event_to_coords($w_canvas->XEvent);
  foreach(keys %Stack::stack) {
    my $id = $_;
    my $obj = $Stack::stack{$id};
    if(defined($obj->{Y})  and ($obj->{Y}  >= $y)) { 
      $obj->{Y}  ++;
      $w_canvas->move("id:$id", 0, $g_grid_y); 
    }
    if(defined($obj->{Y1}) and ($obj->{Y1} >= $y)) { 
      $obj->{Y1} ++; 
      $w_canvas->delete("id:$id"); $obj->draw;
    }
    if(defined($obj->{Y2}) and ($obj->{Y2} >= $y)) { 
      $obj->{Y2} ++; 
      $w_canvas->delete("id:$id"); $obj->draw;
    }
  }
}  
sub mode_remove_line_here {
  my($x,$y) = event_to_coords($w_canvas->XEvent);
  foreach(keys %Stack::stack) {
    my $id = $_;
    my $obj = $Stack::stack{$id};
    if(defined($obj->{Y})  and $obj->{Y}  > $y) { 
      $obj->{Y}  --; 
      $w_canvas->move("id:$id", 0, -$g_grid_y); 
    }
    if(defined($obj->{Y1}) and $obj->{Y1} > $y) { 
      $obj->{Y1} --; 
      $w_canvas->delete("id:$id"); $obj->draw;
    }
    if(defined($obj->{Y2}) and $obj->{Y2} > $y) { 
      $obj->{Y2} --; 
      $w_canvas->delete("id:$id"); $obj->draw;
    }
  }
}  
